#pragma once
#include "../acl_cpp_define.hpp"
#include <list>
#include "../db/db_handle.hpp"
#include "../connpool/connect_pool.hpp"

#if !defined(ACL_DB_DISABLE)

namespace acl {

class db_handle;
class locker;

class ACL_CPP_API db_pool : public connect_pool
{
public:
	/**
	 * ݿ⹹캯
	 * @param dbaddr {const char*} ݿַ
	 * @param count {size_t} ӳӸ
	 * @param idx {size_t} ӳضڼе±λ( 0 ʼ)
	 */
	db_pool(const char* dbaddr, size_t count, size_t idx = 0);
	virtual ~db_pool() {};

	/**
	 * ݿӳػһݿ󣬲Ҫݿӣû
	 * ʽٵ db_handle::open ̣
	 *  db_pool->put(db_handle*) ӹ黹ݿӳأ
	 * ɸúõӾ deleteӳصڲ
	 * @return {db_handle*} ݿӶ󣬷ؿձʾ
	 */
	db_handle* peek_open();

	/**
	 * õǰݿӳص
	 * @return {size_t}
	 */
	size_t get_dblimit() const
	{
		return get_max();
	}

	/**
	 * õǰݿӳصǰ
	 * @return {size_t}
	 */
	size_t get_dbcount() const
	{
		return get_count();
	}

	/**
	 * ݿӳпӵ()
	 * @param ttl {int} ()
	 */
	void set_idle(int ttl)
	{
		set_idle_ttl(ttl);
	}
};

class ACL_CPP_API db_guard : public connect_guard
{
public:
	db_guard(db_pool& pool) : connect_guard(pool) {}
	~db_guard(void);
};

} // namespace acl

#endif // !defined(ACL_DB_DISABLE)
