#pragma once
#include "../acl_cpp_define.hpp"
#include "../connpool/connect_pool.hpp"

namespace acl
{

class sslbase_conf;

/**
 * http ͻӳุ࣬Ϊ connect_poolֻʵָе麯
 * create_connect ӵӳظ connect_pool Ĺܣ⣬ഴ
 * Ӷ http_reuqest ڵ connect_pool::peek ʱ
 * ı http_request ࣬Ҫ peek صǿתΪ http_request
 * 󣬱ʹ http_request йܣ http_reuqest Ϊ
 * connect_client 
 */
class ACL_CPP_API http_request_pool : public connect_pool
{
public:
	/**
	 * 캯
	 * @param addr {const char*} ַʽip:port(domain:port)
	 * @param count {size_t} ӳӸƣֵΪ 0 ʱû
	 * @param idx {size_t} ӳضڼе±λ( 0 ʼ)
	 */
	http_request_pool(const char* addr, size_t count, size_t idx = 0);
	~http_request_pool();

	/**
	 * ñ SSL Ŀͻģʽ
	 * @param ssl_conf {sslbase_conf*}
	 */
	void set_ssl(sslbase_conf* ssl_conf);

protected:
	// ി麯úغɻøӳصӼ IO ʱʱ
	virtual connect_client* create_connect();

private:
	sslbase_conf* ssl_conf_;
};

class ACL_CPP_API http_guard : public connect_guard
{
public:
	http_guard(http_request_pool& pool);
	~http_guard(void);
};

} // namespace acl
